<?php

/**
 * cierre_encargo_sig_mes actions.
 *
 * @package    nomina
 * @subpackage cierre_encargo_sig_mes
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class cierre_encargo_sig_mesActions extends sfActions {

    /**
     * Metodo que trae encargos que se terminan en elsiguiente mes del periodo de filtro
     *
     * @param sfWebRequest $request
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------/  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        //manejo de errores
        try {

            /*
             * Variables obligatorias
             */
            $id_periodo = $request['id_periodo'];


            /*
             * Variables opcionales
             */


            /*
             * Paginacion
             */
            if (isset($request['_startRow'])) {
                $rowStart = $request['_startRow'];
            } else {
                $rowStart = 0;
            }

            if (isset($request['_endRow'])) {
                $rowEnd = $request['_endRow'];
            } else {
                $rowEnd = 75;
            }

            /*
             * Formato de fecha sin time
             */
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;

            CN_TABLE::executeSQL($sql);


            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            /*
              To_Char(Tab0.Fecha_Proceso, 'YYYY-MM-DD') Between '$fecha_ini' And '$fecha_fin'
              and Tab0.estado = $estado
              $whereTercero
             */
            $sql = <<<EOD

select count(*) as count from (

select
(select  id_anhos ||'-'|| lpad(id_meses,2,'0') || '-01' from no_periodo where id_periodo = $id_periodo)  as fecha,
$id_periodo as id_periodo,
id_novedad_personal,
ID_TIPO_DOC,
num_doc,
4 as ID_NOVEDAD,
fecha_inicial,
FECHA_TERMINACION,
doc_soporte,
FECHA_SOPORTE,
id_dp_ini,
ID_DP_FIN,
--ID_PERIODO,
ESTADO
from no_novedad_personal
where 
id_novedad in (3,7)
and estado = 1
and fecha_terminacion between to_date( (select   id_anhos||'-'||lpad(id_meses,2,'0')  from no_periodo where id_periodo = $id_periodo) || '-01' ,'YYYY-MM-DD')  + interval '1' month
    and trunc(last_day( to_date( (select   id_anhos||'-'||lpad(id_meses,2,'0')  from no_periodo where id_periodo = $id_periodo) || '-01' ,'YYYY-MM-DD') + interval '1' month )) 

)

EOD;


            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];

            /*
             * consulta para determinar Terminar encargos para el periodo creado
             */
            //id 3 novedad de encargo
            //id 4 novedad de terminacion de encargo
            //obtener el listado de recaudos
            $sql = <<<EOD

SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (

select
(select  id_anhos ||'-'|| lpad(id_meses,2,'0') || '-01' from no_periodo where id_periodo = $id_periodo)  as fecha,
$id_periodo as id_periodo,
id_novedad_personal,
ID_TIPO_DOC,
num_doc,
4 as ID_NOVEDAD,
fecha_inicial,
FECHA_TERMINACION,
doc_soporte,
FECHA_SOPORTE,
id_dp_ini,
ID_DP_FIN,
--ID_PERIODO,
ESTADO
from no_novedad_personal
where 
id_novedad in (3,7)
and estado = 1
and fecha_terminacion between to_date( (select   id_anhos||'-'||lpad(id_meses,2,'0')  from no_periodo where id_periodo = $id_periodo) || '-01' ,'YYYY-MM-DD')  + interval '1' month
and trunc(last_day( to_date( (select   id_anhos||'-'||lpad(id_meses,2,'0')  from no_periodo where id_periodo = $id_periodo) || '-01' ,'YYYY-MM-DD') + interval '1' month )) 

            
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart

EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $this->startRow + count($resultado);
            $this->list_data = $resultado;

            if (count($resultado) > 0) {
                $this->status = 2;
            }
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
